// ======================== MSP430F4xxx D/A ͸  ======================
//  CPU : MSP430F4250
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : IAR-MSP430
// [ ]  : ACLK : 32.768Khz
//            MCLK : DCO(7.995392MHz)
//            SMCLK: DCO(7.995392MHz)
// ----------------------------------------------------------------------------
// ⺻ 
#include "msp430x42x0.h"
#include <stdio.h>

// Լ 
void cpu_setup(void);						// CPU ʱȭ
void dac_set(void);						// DAC 

//  

// ===============================  α׷ ==============================
// [μ]: void
// [] D/A Output 12Bit DAC0(P1.4) : 0-AVcc( )
// ---------------------------------------------------------------------------
int main(void)
{
unsigned datau =0;
	
	cpu_setup();						// cpuʱȭ
	dac_set();						// DAC 
	_EINT();						// Enable interrupts

	while(1){
		DAC12_0DAT = datau++;				// DAC Output Data
		if(datau >= 4095U) datau = 0;
	}
}

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
unsigned dly;
	
	WDTCTL = WDTPW + WDTHOLD;				// Init watchdog timer(stop)
	for(dly = 0; dly < 0x4000U; dly++) ;			// XTAL  ð 

	SCFI0 |= FN_4;						// Set DCO operating range
	SCFQCTL = 121;						// (121+1) x 32768(ACLK) x 2 = 7.99 Mhz
	FLL_CTL0 = DCOPLUS + XCAP18PF;				// DCO+ set so freq = xtal x D x N+1
}

// ============================== ADC10  ==================================
// [μ] void
// [] DAC Output : 0-AVcc
// ----------------------------------------------------------------------------
void dac_set(void)
{
// DAC o/p external, Ref Voltage = AVcc,
// O/p Voltage range = 1x ref, Enable conversion 1
	DAC12_0CTL = DAC12OPS + DAC12SREF_1 + DAC12IR + DAC12AMP_5 + DAC12ENC;
}
