// ========================== MSP430F4xxx Ʈ  α׷ ==================
//  CPU : MSP430F4250
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : IAR-MSP430
// [ ]  : ACLK : 32.768Khz
//            MCLK : DCO(7.995392MHz)
//            SMCLK: DCO(7.995392MHz)
// ----------------------------------------------------------------------------
// ⺻ 
#include "msp430x42x0.h"
#include <stdio.h>

// Լ 


//  

// ===============================  α׷ ==============================
// [μ]: void
// []: P1.0-7 : ALL Output
//         P2.0-7 : ALL Output
//         P5.0-7 : ALL Output
//         P6.0-7 : ALL Output
//          1 0 
// ---------------------------------------------------------------------------
int main(void)
{
long datal = 0x000001;
long dly;

	WDTCTL = WDTPW + WDTHOLD;				// Init watchdog timer(stop)
	for(dly = 0; dly < 0x4000U; dly++) ;			// XTAL  ð 

	SCFI0 |= FN_3;						// Set DCO operating range
	SCFQCTL = 121;						// (121+1) x 32768(ACLK) x 2 = 7.99 Mhz
	FLL_CTL0 = DCOPLUS + XCAP18PF;				// DCO+ set so freq = xtal x D x N+1

	P1DIR = 0xff;						// Port1 All Output
	P2DIR = 0xff;						// Port2 All Output
	P5DIR = 0xff;						// Port3 All Output
	P6DIR = 0xff;						// Port3 All Output
	while(1){
		P1OUT = ~datal & 0xff;				// PORT1 Out
		P2OUT = (~datal >> 8) & 0xff;			// PORT2 Out
		P5OUT = (~datal >> 16) & 0xff;			// PORT5 Out
		P6OUT = (~datal >> 24) & 0xff;			// PORT6 Out
		for(dly = 0; dly < 500000; dly++);		// delay 400ms
		datal = datal << 1;				//  Ʈ << 1
		if(datal == 0x0000000L) datal = 0x01;
	}
}
