// =========================== MSP430F4xxx Ŭ  α׷ =================
//  CPU : MSP430F4250
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : mspgcc+Dev-C++
// [ ]  : ACLK : 32.768Khz
//            MCLK : DCO(7.995392MHz)
//            SMCLK: DCO(7.995392MHz)
// ----------------------------------------------------------------------------
// ⺻ 
#include <io.h>
#include <stdio.h>
#include <signal.h>
#include <iomacros.h>

// Լ 

//  

// ===============================  α׷ ==============================
// [μ]: void
// []: P1.0 : PULSE Output
//         P1.1 : MCLK Output
//	   P1.5 : ACLK  Output
// ---------------------------------------------------------------------------
int main(void)
{
unsigned dly;
	
	WDTCTL = WDTPW + WDTHOLD;				// Init watchdog timer(stop)
	for(dly = 0; dly < 0x4000U; dly++) ;			// XTAL  ð 

	SCFI0 |= FN_3;						// Set DCO operating range
	SCFQCTL = 121;						// (121+1) x 32768(ACLK) x 2 = 7.99 Mhz
	FLL_CTL0 = DCOPLUS + XCAP18PF;				// DCO+ set so freq = xtal x D x N+1

	P1DIR |= 0x23;						// P1.0,P1.1,P1.5 outputs
	P1SEL |= 0x22;						// P1.4 SMCLK output
	while(1){
		P1OUT ^= 0x01;					// Toggle P1.0
	}
}
